// Defining the Dot
class Dot {
  float minSize;
  float maxSize;
  float size;
  float x;
  float y;
  boolean grow;
  float r;
  float g;
  float b;
  PVector location;
  PVector velocity;
  
  Dot() {
    // For changing sizes, set a min and max size
    minSize = random(4, 199);
    maxSize = random(201, 400);
    size = minSize; // Start at the min size
    // Start in a random location
    x = random(width);
    y = random(height);
    location = new PVector(x, y);
    velocity = new PVector(random(-4, 4), random(-4, 4)); // Move the Dot
    grow = true; // Tells the Dot whether to grow in size
    // Random darkish colors: red, blue, and green
    r = random(128);
    g = random(128);
    b = random(128);
  }
  
  void show(float s) {
    // Grow if we reach the min size
    if (size < minSize) {
      grow = true;
    }
    
    // Shrink if we reach the max size
    if (size > maxSize) {
      grow = false;
    }
    
    // Check what we just said
    if (grow) {
      size += s; // Grow
    }
    else {
      size -= s; // Shrink
    }
    
    // Change the velocity of the Dot
    location.add(velocity);
    
    // Don't go off the edge of the sketch
    if (location.x > width || location.x < 0) {
      velocity.x = -1*velocity.x;
    }
    
    // Don't go off the edge of the sketch
    if (location.y > height || location.y < 0) {
      velocity.y = -1*velocity.y;
    }
    
    // Draw the Dot
    fill(r, g, b);
    ellipse(location.x, location.y, size, size);
  }
}
